From 06711bc251b4b2e5895fe5a4647cf1f782dcfc9d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 20 2020 03:29:58 +0000
Subject: [PATCH 1462/2232] Check std::is_enum on extern enum


Without this, something that is not an enum could have been able to pass
our assertions, resulting in unpredictable behavior.

    // rust
    enum FakeEnum { K = 1usize }
    extern "C++" { type FakeEnum; }

    // c++
    struct FakeEnum {
      static const int K = 1;
      const char *x;
    };

There may be valid reasons to want something of this sort to work, but
forbid for now and someone will need to bring forward a concrete use
case for consideration.

---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 71d6163..d997786 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -269,6 +269,12 @@ fn write_enum<'a>(out: &mut OutFile<'a>, enm: &'a Enum) {
 
 fn check_enum<'a>(out: &mut OutFile<'a>, enm: &'a Enum) {
     out.set_namespace(&enm.name.namespace);
+    out.include.type_traits = true;
+    writeln!(
+        out,
+        "static_assert(::std::is_enum<{}>::value, \"expected enum\");",
+        enm.name.cxx,
+    );
     write!(out, "static_assert(sizeof({}) == sizeof(", enm.name.cxx);
     write_atom(out, enm.repr);
     writeln!(out, "), \"incorrect size\");");

